package com.txznet.android_call;

import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.telephony.TelephonyManager;
import android.util.Log;

import com.txznet.sdk.TXZCallManager.Contact;

public class AndroidCallStateReceiver extends BroadcastReceiver {
	private static final String TAG = "AndroidCallStateReceiver";
	private static final String ACTION_PHONE_STATE = "android.intent.action.PHONE_STATE";

	@Override
	public void onReceive(Context context, Intent intent) {
		Log.d(TAG, "onReceive:intent " + intent);

		String action = intent.getAction();
		if (Intent.ACTION_NEW_OUTGOING_CALL.equals(action)) {
			Contact con = new Contact();
			con.setNumber(intent.getStringExtra(Intent.EXTRA_PHONE_NUMBER));

			AndroidCallTool.onMakeCall(con);
		} else if (ACTION_PHONE_STATE.equals(action)) {
			// 来电
			TelephonyManager tm = (TelephonyManager) context
					.getSystemService(Service.TELEPHONY_SERVICE);
			switch (tm.getCallState()) {
			case TelephonyManager.CALL_STATE_RINGING:
				Contact con = new Contact();
				con.setNumber(intent
						.getStringExtra(TelephonyManager.EXTRA_INCOMING_NUMBER));

				AndroidCallTool.onIncoming(con);
				break;
			case TelephonyManager.CALL_STATE_OFFHOOK:
				AndroidCallTool.onOffhook();
				break;
			case TelephonyManager.CALL_STATE_IDLE:
				AndroidCallTool.onIdle();
				break;
			default:
				Log.e(TAG, "unknown phont state:" + tm.getCallState());
				break;
			}
		}
	}
}
